using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Linq;
using Crestron;
using Crestron.Logos.SplusLibrary;
using Crestron.Logos.SplusObjects;
using Crestron.SimplSharp;
using Isc.Driver.Nest.Simpl;
using Isc.Driver.Cloud;
using Isc.Driver.Cloud.Implementation;
using Isc.Driver.Helper.Logger;
using Isc.Driver.Helper.Https;
using Isc.Driver.Helper.Http;
using Isc.Driver.Helper.FileWrapper;
using Isc.Driver.Helper.Timer;
using Isc.Driver.License;
using Isc.Driver.Nest.Response;
using Isc.Driver.Nest;
using Isc.Driver.Nest.RequestBody;

namespace UserModule_NESTTHERMOSTAT
{
    public class UserModuleClass_NESTTHERMOSTAT : SplusObject
    {
        static CCriticalSection g_criticalSection = new CCriticalSection();
        
        Crestron.Logos.SplusObjects.AnalogInput SETCOOLSETPOINT;
        Crestron.Logos.SplusObjects.AnalogInput SETHEATSETPOINT;
        Crestron.Logos.SplusObjects.AnalogInput SETHVACMODE;
        Crestron.Logos.SplusObjects.StringInput STATEUPDATE;
        Crestron.Logos.SplusObjects.DigitalOutput ISONLINEFB;
        Crestron.Logos.SplusObjects.DigitalOutput ISCELSIUSFB;
        Crestron.Logos.SplusObjects.AnalogOutput TEMPERATUREFB;
        Crestron.Logos.SplusObjects.AnalogOutput COOLHOLDTEMPFB;
        Crestron.Logos.SplusObjects.AnalogOutput HEATHOLDTEMPFB;
        Crestron.Logos.SplusObjects.AnalogOutput HUMIDITYFB;
        Crestron.Logos.SplusObjects.StringOutput HVACMODEFB;
        Crestron.Logos.SplusObjects.StringOutput SENDCOMMAND;
        StringParameter NAME;
        Isc.Driver.Nest.Simpl.SimplThermostat API;
        public void ONUPDATEUIHANDLER ( object __sender__ /*Isc.Driver.Nest.Simpl.SimplThermostat SENDER */, Isc.Driver.Nest.Simpl.UpdateUiEventArgs ARGS ) 
            { 
            SimplThermostat  SENDER  = (SimplThermostat )__sender__;
            try
            {
                SplusExecutionContext __context__ = SplusSimplSharpDelegateThreadStartCode();
                
                __context__.SourceCodeLine = 29;
                ISONLINEFB  .Value = (ushort) ( ARGS.IsOnline ) ; 
                __context__.SourceCodeLine = 30;
                ISCELSIUSFB  .Value = (ushort) ( ARGS.IsCelsius ) ; 
                __context__.SourceCodeLine = 31;
                HUMIDITYFB  .Value = (ushort) ( ARGS.Humidity ) ; 
                __context__.SourceCodeLine = 32;
                TEMPERATUREFB  .Value = (ushort) ( ARGS.Temperature ) ; 
                __context__.SourceCodeLine = 33;
                COOLHOLDTEMPFB  .Value = (ushort) ( ARGS.CoolHoldTemp ) ; 
                __context__.SourceCodeLine = 34;
                HEATHOLDTEMPFB  .Value = (ushort) ( ARGS.HeatHoldTemp ) ; 
                __context__.SourceCodeLine = 35;
                HVACMODEFB  .UpdateValue ( ARGS . HvacMode  ) ; 
                
                
            }
            finally { ObjectFinallyHandler(); }
            }
            
        object SETCOOLSETPOINT_OnChange_0 ( Object __EventInfo__ )
        
            { 
            Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
            try
            {
                SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
                
                __context__.SourceCodeLine = 40;
                SENDCOMMAND  .UpdateValue ( API . SetCoolSetpoint ( (ushort)( SETCOOLSETPOINT  .UshortValue ))  ) ; 
                
                
            }
            catch(Exception e) { ObjectCatchHandler(e); }
            finally { ObjectFinallyHandler( __SignalEventArg__ ); }
            return this;
            
        }
        
    object SETHEATSETPOINT_OnChange_1 ( Object __EventInfo__ )
    
        { 
        Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
        try
        {
            SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
            
            __context__.SourceCodeLine = 45;
            SENDCOMMAND  .UpdateValue ( API . SetHeatSetpoint ( (ushort)( SETHEATSETPOINT  .UshortValue ))  ) ; 
            
            
        }
        catch(Exception e) { ObjectCatchHandler(e); }
        finally { ObjectFinallyHandler( __SignalEventArg__ ); }
        return this;
        
    }
    
object SETHVACMODE_OnChange_2 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 50;
        SENDCOMMAND  .UpdateValue ( API . SetHvacMode ( (ushort)( SETHVACMODE  .UshortValue ))  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object STATEUPDATE_OnChange_3 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 55;
        API . OnSendUpdate ( STATEUPDATE .ToString()) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

public override object FunctionMain (  object __obj__ ) 
    { 
    try
    {
        SplusExecutionContext __context__ = SplusFunctionMainStartCode();
        
        __context__.SourceCodeLine = 60;
        WaitForInitializationComplete ( ) ; 
        __context__.SourceCodeLine = 61;
        API . Init ( NAME  .ToString()) ; 
        __context__.SourceCodeLine = 62;
        // RegisterEvent( API , ONUPDATEUI , ONUPDATEUIHANDLER ) 
        try { g_criticalSection.Enter(); API .OnUpdateUi  += ONUPDATEUIHANDLER; } finally { g_criticalSection.Leave(); }
        ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler(); }
    return __obj__;
    }
    

public override void LogosSplusInitialize()
{
    _SplusNVRAM = new SplusNVRAM( this );
    
    ISONLINEFB = new Crestron.Logos.SplusObjects.DigitalOutput( ISONLINEFB__DigitalOutput__, this );
    m_DigitalOutputList.Add( ISONLINEFB__DigitalOutput__, ISONLINEFB );
    
    ISCELSIUSFB = new Crestron.Logos.SplusObjects.DigitalOutput( ISCELSIUSFB__DigitalOutput__, this );
    m_DigitalOutputList.Add( ISCELSIUSFB__DigitalOutput__, ISCELSIUSFB );
    
    SETCOOLSETPOINT = new Crestron.Logos.SplusObjects.AnalogInput( SETCOOLSETPOINT__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SETCOOLSETPOINT__AnalogSerialInput__, SETCOOLSETPOINT );
    
    SETHEATSETPOINT = new Crestron.Logos.SplusObjects.AnalogInput( SETHEATSETPOINT__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SETHEATSETPOINT__AnalogSerialInput__, SETHEATSETPOINT );
    
    SETHVACMODE = new Crestron.Logos.SplusObjects.AnalogInput( SETHVACMODE__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SETHVACMODE__AnalogSerialInput__, SETHVACMODE );
    
    TEMPERATUREFB = new Crestron.Logos.SplusObjects.AnalogOutput( TEMPERATUREFB__AnalogSerialOutput__, this );
    m_AnalogOutputList.Add( TEMPERATUREFB__AnalogSerialOutput__, TEMPERATUREFB );
    
    COOLHOLDTEMPFB = new Crestron.Logos.SplusObjects.AnalogOutput( COOLHOLDTEMPFB__AnalogSerialOutput__, this );
    m_AnalogOutputList.Add( COOLHOLDTEMPFB__AnalogSerialOutput__, COOLHOLDTEMPFB );
    
    HEATHOLDTEMPFB = new Crestron.Logos.SplusObjects.AnalogOutput( HEATHOLDTEMPFB__AnalogSerialOutput__, this );
    m_AnalogOutputList.Add( HEATHOLDTEMPFB__AnalogSerialOutput__, HEATHOLDTEMPFB );
    
    HUMIDITYFB = new Crestron.Logos.SplusObjects.AnalogOutput( HUMIDITYFB__AnalogSerialOutput__, this );
    m_AnalogOutputList.Add( HUMIDITYFB__AnalogSerialOutput__, HUMIDITYFB );
    
    STATEUPDATE = new Crestron.Logos.SplusObjects.StringInput( STATEUPDATE__AnalogSerialInput__, 255, this );
    m_StringInputList.Add( STATEUPDATE__AnalogSerialInput__, STATEUPDATE );
    
    HVACMODEFB = new Crestron.Logos.SplusObjects.StringOutput( HVACMODEFB__AnalogSerialOutput__, this );
    m_StringOutputList.Add( HVACMODEFB__AnalogSerialOutput__, HVACMODEFB );
    
    SENDCOMMAND = new Crestron.Logos.SplusObjects.StringOutput( SENDCOMMAND__AnalogSerialOutput__, this );
    m_StringOutputList.Add( SENDCOMMAND__AnalogSerialOutput__, SENDCOMMAND );
    
    NAME = new StringParameter( NAME__Parameter__, this );
    m_ParameterList.Add( NAME__Parameter__, NAME );
    
    
    SETCOOLSETPOINT.OnAnalogChange.Add( new InputChangeHandlerWrapper( SETCOOLSETPOINT_OnChange_0, false ) );
    SETHEATSETPOINT.OnAnalogChange.Add( new InputChangeHandlerWrapper( SETHEATSETPOINT_OnChange_1, false ) );
    SETHVACMODE.OnAnalogChange.Add( new InputChangeHandlerWrapper( SETHVACMODE_OnChange_2, false ) );
    STATEUPDATE.OnSerialChange.Add( new InputChangeHandlerWrapper( STATEUPDATE_OnChange_3, false ) );
    
    _SplusNVRAM.PopulateCustomAttributeList( true );
    
    NVRAM = _SplusNVRAM;
    
}

public override void LogosSimplSharpInitialize()
{
    API  = new Isc.Driver.Nest.Simpl.SimplThermostat();
    
    
}

public UserModuleClass_NESTTHERMOSTAT ( string InstanceName, string ReferenceID, Crestron.Logos.SplusObjects.CrestronStringEncoding nEncodingType ) : base( InstanceName, ReferenceID, nEncodingType ) {}




const uint SETCOOLSETPOINT__AnalogSerialInput__ = 0;
const uint SETHEATSETPOINT__AnalogSerialInput__ = 1;
const uint SETHVACMODE__AnalogSerialInput__ = 2;
const uint STATEUPDATE__AnalogSerialInput__ = 3;
const uint ISONLINEFB__DigitalOutput__ = 0;
const uint ISCELSIUSFB__DigitalOutput__ = 1;
const uint TEMPERATUREFB__AnalogSerialOutput__ = 0;
const uint COOLHOLDTEMPFB__AnalogSerialOutput__ = 1;
const uint HEATHOLDTEMPFB__AnalogSerialOutput__ = 2;
const uint HUMIDITYFB__AnalogSerialOutput__ = 3;
const uint HVACMODEFB__AnalogSerialOutput__ = 4;
const uint SENDCOMMAND__AnalogSerialOutput__ = 5;
const uint NAME__Parameter__ = 10;

[SplusStructAttribute(-1, true, false)]
public class SplusNVRAM : SplusStructureBase
{

    public SplusNVRAM( SplusObject __caller__ ) : base( __caller__ ) {}
    
    
}

SplusNVRAM _SplusNVRAM = null;

public class __CEvent__ : CEvent
{
    public __CEvent__() {}
    public void Close() { base.Close(); }
    public int Reset() { return base.Reset() ? 1 : 0; }
    public int Set() { return base.Set() ? 1 : 0; }
    public int Wait( int timeOutInMs ) { return base.Wait( timeOutInMs ) ? 1 : 0; }
}
public class __CMutex__ : CMutex
{
    public __CMutex__() {}
    public void Close() { base.Close(); }
    public void ReleaseMutex() { base.ReleaseMutex(); }
    public int WaitForMutex() { return base.WaitForMutex() ? 1 : 0; }
}
 public int IsNull( object obj ){ return (obj == null) ? 1 : 0; }
}


}
